#include <stdio.h>
#include <math.h>

/**
 * Maksimaalais tomaatu skaits
 */
const SMAX = 100;

/**
 * Kastes rindu un kolonu skaits
 */
long n,m;

/**
 * Tomaatu skaits
 */
int s;

/**
 * Katra sarkanaa tomaata rinda un kolona
 */
long row[SMAX];
long col[SMAX];

/**
 * Intervaalu skaits nokraasoto tomaatu struktuuraa
 */
int count;

/**
 * Intervaalu kreisaas robezhas
 */
long col1[2*SMAX+1];

/**
 * Intervaalu labaas robezhas
 */
long col2[2*SMAX+1];

/**
 * Konkreetaa intervaala lielaakaa nokraasotaa rinda
 */
long highRow[2*SMAX+1];

/**
 * Paliigmasiivi nokraasoto tomaatu struktuuras modificeeshanai
 */
long tCol1[2*SMAX+1];
long tCol2[2*SMAX+1];
long tHighRow[2*SMAX+1];

/**
 * Funkcija, kas ielasa ievaddatus.
 */
void readInput()
{
	FILE *in = fopen("kaste.dat","rt");
	fscanf(in,"%ld %ld %d",&n,&m,&s);
	for (int i = 0; i < s; i++)
	{
		// nolasa kaarteejaa sarkanaa tomaata rindu un kolonu
		fscanf(in,"%ld %ld",&row[i],&col[i]);

		// C indeksaacija saakas ar 0
		row[i]--;
		col[i]--;
	}
	fclose(in);
}

/**
 * Funkcija pievieno kaarteejo intervaalu, kas atbilst tomaatam ar noraadiito
 * indeksu.
 */
void addTomato(int ind,long k)
{
	// rodas jauns intervaals, kas atbilst dotajam tomaatam.
	// Apreekjinaam shii intervaala krieso un labo robezhu, kaa arii
	// lielaako rindas indeksu, kuraa k dienaas dotais tomaats var nokraasot
	// vismaz vienu tomaatu.
	long newCol1 = col[ind]-k;
	if (newCol1 < 0) newCol1 = 0;
	long newCol2 = col[ind]+k;
	if (newCol2 >= m) newCol2 = m-1;
	long newHighRow = row[ind]+k;

	// ja jaunais intervaals paarklaaj kaadu veco, tad modificeejam veco
	// intervaalu. Jaunos intervaalus kraajam analogjiskos paliigmasiivos.

	// jauno intervaalu skaits
	int newCount = 0;

	// apskataam visus vecos intervaalus
	for (int i = 0; i < count; i++)
	{
		if (col1[i] < newCol1)
		{
			// vecajam ir nepaarklaata dalja pa kreisi, taapeec taa dalja ieiet
			// arii jauno intervaalu kopaa
			tCol1[newCount] = col1[i];
			tCol2[newCount] = (newCol1-1 < col2[i]) ? newCol1-1 : col2[i];
			tHighRow[newCount] = highRow[i];
			newCount++;
		}
		if (col2[i] > newCol2)
		{
			// vecajam ir nepaarklaata dalja pa labi, taapeec taa dalja ieiet
			// arii jauno intervaalu kopaa
			tCol1[newCount] = (newCol2+1 > col1[i]) ? newCol2+1 : col1[i];
			tCol2[newCount] = col2[i];
			tHighRow[newCount] = highRow[i];
			newCount++;
		}
	}

	// pievienojam jauno intervaalu
	tCol1[newCount] = newCol1;
	tCol2[newCount] = newCol2;
	tHighRow[newCount] = newHighRow;
	newCount++;

	// saglabaa jauno intervaalu skaitu
	count = newCount;

	// iekopee jaunos intervaalus atpakalj iistajos masiivos
	for (i = 0; i < count; i++)
	{
		col1[i] = tCol1[i];
		col2[i] = tCol2[i];
		highRow[i] = tHighRow[i];
	}
}

/**
 * Funkcija atgriezh mazaako rindu, kuraa ir veel zaljs tomaats. Kastes
 * apaksheejaa mala netiek ieveerota.
 */
long getMinRow()
{
	// Vienkaarshi jaapanjem minimaalaa no veertiibaam highRow[i]+1, t.i.
	// jaapaarbauda visi intervaali

	long minRow = highRow[0]+1;

	for (int i = 1; i < count; i++)
		if (highRow[i]+1 < minRow)
			minRow = highRow[i]+1;

	return minRow;
}

/**
 * Funkcija, kas atgriezh 1 tad un tikai tad, ja ar k dienaam pietiek,
 * lai visi tomaati nokraasotos sarkani.
 * Algoritms darbojas sekojoshi:
 *		Apstraadaa peec kaartas tomaatus rindas pieaugshanas seciibaa.
 * Pienjemsim, ka mees apskataam i-to tomaatu. Apskataam mazaako rindu r,
 * kuraa ir kaads tomaats, ko k dienaas nenokraaso neviens no tomaatiem
 * ar indeksu mazaaku par i. Ja k dienaas i-tais tomaats nevar nokraasot
 * nevienu tomaatu no rindas r, tad to nevarees neviens no sekojoshajiem
 * tomaatiem, un rindaa r paliks zaljsh tomaats. Taatad k dienas ir par maz.
 * Ja savukaart k dienaas i-tais tomaats nokraaso arii kaadu no rindas r,
 * tad pagaidaam viss ir kaartiibaa un varam apskatiit naakosho sarkano
 * tomaatu. Ja visi tomaati ir apskatiiti, tad mums veel ir jaapaarbauda,
 * vai eksistee taada rinda, kuraa ir zaljsh tomaats. Ja nee, tad k dienas
 * pietiek, citaadi nepietiek. Tie tomaati, kurus nokraaso pirmie t sarkanie
 * tomaati, tiek glabaati ar neskjeljoshos intervaalu kopu, kuri noklaaj visu
 * intervaalu [0..m-1]. Katram intervaalam ir savs augstaakaas rindas indeks,
 * un tas noziimee, ka visi tomaati, kuru kolonas indeks ir shajaa
 * intervaalaa un kuru rindas indekss nepaarsniedz sho augstaakaas rindas
 * indeksu, ir sarkani. Apstraadaajot jaunu tomaatu, mums viens intervaals
 * naak klaat, bet paareejie intervaali iespeejams modificeejas (paliek
 * iisaaki vai pat sadalaas divos intervaalos).
 */
int allRed(long k)
{
	// saakumaa neviens tomaats nav nokraasots, taapeec ir viens intervaals
	// no 0 liidz m-1 ar augstumu -1.
	col1[0] = 0; col2[0] = m-1;
	highRow[0] = -1;
	count = 1;

	// apstraadaa sarkanos tomaatus rindu pieaugoshaa seciibaa
	for (int i = 0; i < s; i++)
	{
		// dabuu mazaako rindu, kuraa veel ir zaljs tomaats
		long minRow = getMinRow();

		// ja patiesiibaa taa rinda ir aarpus kastes, tad esam visu
		// nokraasojushi
		if (minRow >= n)
			return 1;

		// ja kaarteejais tomaats nemaz nesniedzas liidz shai rindai,
		// tad visu nokraasot k dienaas nevar
		if (row[i]-k > minRow)
			return 0;

		// pievieno jaunu intervaalu, kas atbilst apskatiitajam tomaatam
		addTomato(i,k);
	}

	// ja mazaakaa rinda ar "zalju tomaatu" (ja mees esam aarpus kastes,
	// tad par zaljiem tomaatiem ir nekorekti runaat, bet tomeer) veel ir
	// kastes robezhaas, tad mums ir palikushi nenokraasoti tomaati. Citaadi
	// viss ir OK.

	if (getMinRow() < n)
		return 0;
	else
		return 1;
}

/**
 * Funkcija, kas noskaidro mazaako dienu skaitu, kas nepiecieshams, lai
 * visi tomaati buutu sarkani.
 */
long minDays()
{
	// min un max ir apaksheejaa un augsheejaa robezha intervaalam, kuraa
	// atrodas mekleejamais mazaakais dienu skaits

	// vismaz 0 dienas jau nu vajadzees
	long min = 0;

	// par augsheejo robezhu der maksimaalaa no veertiibaam n-1 un m-1, jo
	// pat ja ir tikai viens sarkans tomaats, tas tik dienaas noteikti nokraaso
	// visu kasti
	long max = (n > m) ? n-1 : m-1;

	// ar intervaala daliishanas metodi samazinaam sho intervaalu liidz vienam
	// elementam taa, lai mekleetais dienu skaits veel ir shajaa intervaalaa

	while (min < max)
	{
		// njemem videejo elementu no intervaala
		long k = (min+max)/2;

		// ja ar tik dienaam pietiek, lai nokraasotu visu kasti, tad mees varam
		// samazinaat augsheejo robezhu uz k, citaadi apaksheejo robezhu var
		// samazinaat uz k+1

		if (allRed(k))
			max = k;
		else
			min = k+1;
	}

	// vajadziigais dienu skaits atrodas intervaalaa no viena elementa, taatad
	// jebkura shii intervaala robezha arii ir mekleetais mazaakais
	// nepiecieshamo dienu skaits
	return min;
}

/**
 * Funkcija sakaarto tomaatus rindas pieaugshanas seciibaa.
 */
void sortTomatos()
{
	for (int i = 0; i < s; i++)
		for (int j = i+1; j < s; j++)
			if (row[i] > row[j])
			{
				long temp = row[i]; row[i] = row[j]; row[j] = temp;
				temp = col[i]; col[i] = col[j]; col[j] = temp;
			}
}

void main()
{
	// nolasaam ievaddatus
	readInput();

	// sakaarto tomaatus rindas pieaugshanas kaartiibaa
	sortTomatos();

	FILE *out = fopen("kaste.rez","wt");

	// izdrukaa mazaako nepiecieshamo dienu skaitu
	fprintf(out,"%ld\n",minDays());

	fclose(out);
}

